!  Invintp = Invintp-1 Inverse interpolate preconditioned
!	<in.H	Invintp o1= d1=  >out.H
!  input- 	in.H	in(2,n2) = ordinate, coordinate pairs.
!		n1	output model size.
!  output- out.H	inverse linear interpolated model mesh mm(m1) 
!%
program zyxabc
implicit none
real, allocatable, dimension (:,:) :: pair
real, allocatable, dimension (:) :: ord
real, allocatable, dimension (:) :: dd
real, allocatable, dimension (:) :: mm
integer n1, nd, m1, esize
integer getch, hetch, putch
call initpar() 
call doc('/home/kana/sep/prof/gem/prc/invint/Invintp2.rst') 
if (0==hetch('n1','d',n1)) then
  call seperr('Could not obtain n1 from history')
end if
if (0/=putch('From history: n1','d',n1)) then
  call seperr('trouble writing n1 to history file')
end if
if (0==hetch('n2','d',nd)) then
  call seperr('Could not obtain n2 from history')
end if
if (0/=putch('From history: n2','d',nd)) then
  call seperr('trouble writing n2 to history file')
end if
if (0==hetch('esize','d',esize)) then
  call seperr('Could not obtain esize from history')
end if
if (0/=putch('From history: esize','d',esize)) then
  call seperr('trouble writing esize to history file')
end if
if ( esize /= 4) then
  call erexit('bad esize')
end if
if (    n1 /= 2) then
  call erexit('bad n1')
end if
if (0==getch('n1','d',m1)) then
  m1=200
end if
if (0/=putch('From par: n1','d',m1)) then
  call seperr('trouble writing n1 to history file')
end if
allocate (pair(2,nd), ord(nd), dd(nd), mm(m1))
call doit ( pair, ord, dd, nd, mm, m1)
end program zyxabc 
subroutine doit( pair, ord, dd, nd, mm, m1)
implicit none
integer	i1,                     nd,     m1, niter
real   pair(2,nd), ord(nd), dd(nd), mm(m1),     o1,d1, eps, rho
integer getch, putch
if (0==getch('niter','d',niter)) then
  niter=(m1*3)/2
end if
if (0/=putch('From par: niter','d',niter)) then
  call seperr('trouble writing niter to history file')
end if
if (0==getch('o1','f',o1)) then
  o1=0.
end if
if (0/=putch('From par: o1','f',o1)) then
  call seperr('trouble writing o1 to history file')
end if
if (0==getch('d1','f',d1)) then
  d1=1/(m1-1.)
end if
if (0/=putch('From par: d1','f',d1)) then
  call seperr('trouble writing d1 to history file')
end if
if (0==getch('rho','f',rho)) then
  rho=.5
end if
if (0/=putch('From par: rho','f',rho)) then
  call seperr('trouble writing rho to history file')
end if
if (0==getch('eps','f',eps)) then
  eps=.1
end if
if (0/=putch('From par: eps','f',eps)) then
  call seperr('trouble writing eps to history file')
end if
if (0 .ne. putch( 'n2', 'i', 1)) then
  call erexit ('trouble writing to history file')
end if
if (0 .ne. putch( 'd1', 'r', 1.)) then
  call erexit ('trouble writing to history file')
end if
call sreed(  'in', pair,  4*2*nd)
do i1=1,nd  
  ord(i1) = pair(1,i1)
  dd (i1) = pair(2,i1)
end do 
call invintw1(  ord, dd,nd,  o1,d1, mm,m1, niter, rho, eps)
call hclose()					!close header, no more putch
call srite( 'out',   mm, 4*m1)
return
end
!  invintp1 = invintp1-1 INVerse interpolation with integration p
!reconditioning
!
subroutine invintw1( ord,     dd,nd,  o1,d1, mm,m1, niter, rho,eps)
implicit none
integer iter,                    nd,            m1, niter,         nr,rd&
,rm
real                 ord(nd), dd(nd), o1,d1, mm(m1),       rho,eps
real xx(m1),dx(m1),sx(m1),dm(m1),rr(nd+m1),dr(nd+m1),sr(nd+m1)
nr= nd+m1
rd=1
rm=1+nd
call null (                   xx,m1        )       !  x   = 0
call null (                   mm,m1        )       !  m   = 0
call null (                          rr(rm),m1)    !  r_m = 0  (=
!I m)
call negcopy(     nd,         dd,    rr(rd))       !  r_d = -d
do iter= 0, niter  
  call lint1(   1, 0, o1,d1, ord, dm,m1, rr(rd), nd) !        dm=
! L' r_d
  call asymleak(1, 0, rho, dx,m1, dm )               ! dx= C' dm
  call ident(   1, 1, eps, m1,  dx,    rr(rm))       ! dx= C'L'r_
!d+eps*r_m
! ----------
  call asymleak(0, 0, rho, dx,m1, dm )               !          d
!m= C dx
  call lint1(   0, 0, o1,d1, ord, dm,m1, dr(rd), nd) ! dr_d = L d
!m
  call ident(   0, 0, eps, m1,  dx,      dr(rm))     ! dr_m = eps
! I dx  
  call cgplus( iter, m1, xx, dx, sx, nr, rr, dr, sr )
  call asymleak( 0, 0, rho, xx,m1, mm )            ! movies  m=Cx
  call snap('mm',m1,1,mm)
  call snap('rr',nr,1,rr) # movies
end do 
call 	    asymleak(  0, 0, rho, xx,m1, mm )
return
end 
