program BIN
  ! Move depths to have zero mean.
  ! Find and set o1,d1,o2,d2
  use sep
  use int2
  use interp
  use quantile_mod

  implicit none
  integer                               :: m1,nd
  integer, dimension (2)                :: n, nb = (/ 1, 1 /)
  real,    dimension (:,:), allocatable :: hh, count, xy
  real,    dimension (:),   allocatable :: ones, v
  real                                  :: xmin,xmax,ymin,ymax,vmin,vmax
  real,    dimension (2)                :: o, d

  call sep_init ()
  call from_history (nd, m1) ; if( m1 /= 3) call erexit( 'm1 /= 3')
  call from_par ("n1", n (1), 200)
  call from_par ("n2", n (2), 200)
  call to_history ("n3", 1)

  call to_history ("label1","x-coordinate")
  call to_history ("label2","y-coordinate")

  allocate (xy (nd,2)) ; call sep_read (xy) 

  xmin = minval (xy (:,1)) ; xmax = maxval (xy (:,1))
  ymin = minval (xy (:,2)) ; ymax = maxval (xy (:,2))

  call from_par ("o1",o (1),xmin) 
  call from_par ("o2",o (2),ymin) 

  call from_par ("d1",d (1),(xmax-xmin)/(n (1) - 1))
  call from_par ("d2",d (2),(ymax-ymin)/(n (2) - 1))
  call sep_close()
  call int2_init (xy, o, d, n, bin2_int, nb)

  allocate (v (nd), ones (nd), hh (n (1), n (2)), count (n (1), n (2)))
  call sep_read (v) 
  vmin = quantile (.01, v) ; where (v < vmin) v = vmin
  vmax = quantile (.99, v) ; where (v > vmax) v = vmax
  v = (vmin + vmax) / 2 - v
  hh = 0. ; count = 0. ; ones = 1.

  call int2_apply (.true.,hh,v)
  call int2_apply (.true.,count,ones)
  where (count > 0.) hh = hh / count ; call sep_write (hh)

  deallocate (xy, v, hh, count, ones)
  call exit(0)
end program BIN



