program Histogram
  use sep
  use quantile_mod

  implicit none
  integer                          :: n1, n2, n3, n, nh, i, dn, ih
  real, dimension (:), allocatable :: x, h
  real                             :: qmin, qmax, xmin, xmax, dh

  call sep_init ()
  call from_history (n1,n2,n3) ; n = n1*n2*n3
  call from_par ("nh",nh,10)
  call to_history ("n1",n)
  call to_history ("n2",1)
  call to_history ("n3",1)

  allocate (x (n), h (n))
  call sep_read (x)

  call from_par ("xmin", xmin, minval (x))
  call from_par ("xmax", xmax, maxval (x))
  dh = (xmax - xmin) / (n -1) ; dn = n/nh

  call to_history ("o1",xmin)
  call to_history ("d1",dh)
  call sep_close ()

  h = 0.
  do i = 1, n - dn, dn
        qmin = xmin + dh * (i - 1)
        qmax = qmin + dh * dn
        ih = count (x >= qmin .and. x <= qmax)
        write (0,*) ih, " values from ",qmin," to ",qmax 
        h (i:i+dn) = ih
  end do

  call sep_write (h)
  deallocate (x, h)
  call exit (0)
end program Histogram







