program vec
  ! Draw seabeam tracks
  ! I plan to change n2 to nd internally.
  use sep
  use quantile_mod

  implicit none
  integer                             :: n1, n2, n3, outfd
  real,    dimension (:,:), pointer   :: data
  real,    dimension (:),   pointer   :: x, y, z
  integer, dimension (:), allocatable :: col
  real                                :: xmin,xmax,ymin,ymax,zmin,zmax
  real                                :: sx, sy

  integer output
  external output

  call sep_init ()
  call from_either (n1,n2,n3) ; if (n2 /= 3) call erexit( 'n2 /= 3')
  call sep_close ()

  allocate (x (n1))
  allocate (y (n1))
  allocate (z (n1))

  allocate ( data (n1,3)) 
  call sep_read (data)
  x => data (1:n1,1)
  y => data (1:n1,2)
  z => data (1:n1,3)

  xmin = minval (x) ; xmax = maxval (x)
  ymin = minval (y) ; ymax = maxval (y)

  zmin = quantile (.01, z)
  zmax = quantile (.99, z)

  sx = (10.24/.75) / (xmax-xmin) ; x = sx * (x -xmin)
  sy =  10.24      / (ymax-ymin) ; y = sy * (y -ymin)

  allocate (col (n1))
  col =  1.+ 6.9 * (zmax - z)/(zmax-zmin)
  where (col < 1) col = 1
  where (col > 7) col = 7

  outfd = output()
  call vpfilep( outfd)
  call vpcolor(7)
  call vptext( .2, .5,  9, 0, ' Sea of Galilee')
  call vptext( .2, .2,  9, 0, ' Zvi ben Avraham')
  call vppenup()
  call draw_track(col,x,y)
  call vpendplot ()

  deallocate (data,col)
  call exit(0)

contains 

  subroutine draw_track (col,x,y)
    integer, dimension (:) :: col
    real,    dimension (:) :: x, y

    integer   :: i, ncol

    do i = 1, size (y)
       if (i <= size (col)) ncol = col (i) 
       call vpcolor(ncol)
       call vpmove( x (i), y (i))
       call vpdraw( x (i), y (i))
    end do
  end subroutine draw_track

end program vec


























