program Invinter
  use sep
  use invint2
  use bound

  implicit none
  integer                               :: n2, nd, m1, niter, meth, filt, if
  real,    dimension (:),   allocatable :: mm
  real,    dimension (:),   pointer     :: coord, ord
  type( filter)                         :: aa
  real,    dimension (:,:), allocatable :: mmov
  real                                  :: o1, d1, eps
 
  call sep_init ()
  ! parameters
  call from_par ("eps",eps, .2)
  call from_par ("method", meth)
  call from_par ("filter", filt)

  ! create model
  call from_par ("n1", m1)
  allocate (mm (m1+filt+1))
  call to_history ("n2", 1)
  call from_par ("niter", niter, m1) ; niter = 1 + niter*3/2 
  call from_history ("o1", o1)
  call from_history ("d1", d1)

  ! read data
  call from_history (nd, n2)
  if (n2 /= 2) call erexit ('bad n2')
  allocate (coord (nd+filt), ord (nd+filt))
  call sep_read (coord(:nd))
  coord (nd+1:) = (/ (o1+(m1-1+if)*d1, if = 1, filt) /) 
  call sep_read (ord(:nd))
  ord (nd+1:) = 0.

  ! create movies
  allocate (mmov (m1, niter))
  call to_history ("n1",m1   ,"mm")
  call to_history ("n2",niter,"mm")
  call to_history ("n3",1    ,"mm")

  call sep_close ()

  call allocatehelix (aa, filt)
!  call boundn ((/ m1 /), (/ m1 /), aa)
  call boundn ((/ m1 /), (/ m1 /), (/ filt /), aa)
  select case (filt)
  case (1)
     aa%flt = -1.
     aa%lag = 1
  case (2)
     aa%flt = (/  -1.858735,      0.8680543  /) !(/ -2., 1. /)
     aa%lag = (/ 1, 2 /)
  end select
  call invint (niter, coord, ord, o1, d1, mm, mmov, eps, aa, (meth /= 1))

  call sep_write (mmov, "mm")
  call sep_write (mm(:m1))

  deallocate (mm, coord, ord, mmov)
  call deallocatehelix (aa)
  call exit (0) 
end program Invinter


